//+------------------------------------------------------------------+
//|                                                          LSS.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property indicator_buffers 1
#property indicator_color1 DarkViolet
//#property indicator_level1 0
//#property indicator_level2 50
//#property indicator_level3 -50

double lss[];

#property indicator_separate_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,lss);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexLabel(0,"LSS Value");
   IndicatorShortName("LSS");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars-6;
//---- 
   for(int i = 0  ;i <= limit  ;i++)
   {
      
       //double h = High[Highest(Symbol(),0,MODE_HIGH,5,i+5)];
       //double l = Low[Lowest(Symbol(),0,MODE_LOW,5,i+5)];
       double h = High[Highest(0,0,MODE_HIGH,5,i+5)];
       double l = Low[Lowest(0,0,MODE_LOW,5,i+5)];
       double x = h - Open[i+5];
       double y = Close[i] - l;
       lss[i] = ((x+y)*100) / ((h-l)*2);
         
   }
//----   
   return(0);
  }
//+------------------------------------------------------------------+